# Class ProxyRemoteMethod<ReturnType, SourceParameter, TargetParameter>`Abstract`

#### Type Parameters

- ReturnType = any
- SourceParameter = any
- TargetParameter = SourceParameter

#### Hierarchy (view full)

- BaseRemoteMethod<ReturnType, SourceParameter>
  - ProxyRemoteMethod

- Defined in packages/angular/remote-method/src/lib/proxy.remote-method.ts:17

#####
Index

### Constructors

constructor

### Properties

__id
_initialised
destroyed$
executed$
executionsInProgress$
initialised$
injector
interceptors
metadata
remoteMethod
destroyed$
initialised$
instances

### Accessors

id

### Methods

_call
applyMetadata
call
destroy
executed
getMetadata
init
ngOnDestroy
pauseRefresh
refresh
resumeRefresh
transformParameters
add
remove

## Constructors

### constructor

- new ProxyRemoteMethod<ReturnType, SourceParameter, TargetParameter>(remoteMethod, injector?, metadata?): ProxyRemoteMethod<ReturnType, SourceParameter, TargetParameter>

- #### Type Parameters

  - ReturnType = any
  - SourceParameter = any
  - TargetParameter = SourceParameter

  #### Parameters

  - remoteMethod: BaseRemoteMethod<any, any, BaseRemoteMethodMetadata>
  - injector: Injector = null
  - metadata: BaseRemoteMethodMetadata = remoteMethod.metadata

  #### Returns ProxyRemoteMethod<ReturnType, SourceParameter, TargetParameter>

  Overrides BaseRemoteMethod.constructor

  - Defined in packages/angular/remote-method/src/lib/proxy.remote-method.ts:20

## Properties

### `Internal` __id

__id: string = ...

unique internal id

Inherited from BaseRemoteMethod.__id

- Defined in packages/angular/definition/src/lib/definition.ts:61

### `Protected` _initialised

_initialised: boolean = false

Inherited from BaseRemoteMethod._initialised

- Defined in packages/angular/definition/src/lib/definition.ts:62

### `Readonly` destroyed$

destroyed$: Subject<void> = ...

Emits if the data source is destroyed

Inherited from BaseRemoteMethod.destroyed$

- Defined in packages/angular/definition/src/lib/definition.ts:48

### executed$

executed$: Subject<ReturnType> = ...

Inherited from BaseRemoteMethod.executed$

- Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:42

### executionsInProgress$

executionsInProgress$: CounterSubject = ...

Inherited from BaseRemoteMethod.executionsInProgress$

- Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:44

### `Readonly` initialised$

initialised$: Subject<void> = ...

Emits if the data source is initialised

Inherited from BaseRemoteMethod.initialised$

- Defined in packages/angular/definition/src/lib/definition.ts:52

### `Readonly` injector

injector: Injector

Inherited from BaseRemoteMethod.injector

- Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:46

### `Readonly` interceptors

interceptors: Set<Subject<any>> = ...

Inherited from BaseRemoteMethod.interceptors

- Defined in packages/angular/definition/src/lib/definition.ts:53

### metadata

metadata: BaseRemoteMethodMetadata

Inherited from BaseRemoteMethod.metadata

- Defined in packages/angular/definition/src/lib/definition.ts:44

### `Private` `Readonly` remoteMethod

remoteMethod: BaseRemoteMethod<any, any, BaseRemoteMethodMetadata>

- Defined in packages/angular/remote-method/src/lib/proxy.remote-method.ts:22

### `Static` `Readonly` destroyed$

destroyed$: Subject<BaseDefinition<BaseDefinitionMetadata>> = ...

Emits when a new Definition instance is initialised

Inherited from BaseRemoteMethod.destroyed$

- Defined in packages/angular/definition/src/lib/definition.ts:41

### `Static` `Readonly` initialised$

initialised$: Subject<BaseDefinition<BaseDefinitionMetadata>> = ...

Emits when a new Definition instance is initialised

Inherited from BaseRemoteMethod.initialised$

- Defined in packages/angular/definition/src/lib/definition.ts:35

### `Static` `Readonly` instances

instances: Map<string, BaseDefinition<BaseDefinitionMetadata>> = ...

A map of active Definition instances

Inherited from BaseRemoteMethod.instances

- Defined in packages/angular/definition/src/lib/definition.ts:27

## Accessors

### id

- get id(): string

- #### Returns string

  Inherited from BaseRemoteMethod.id

  - Defined in packages/angular/definition/src/lib/definition.ts:87

## Methods

### `Protected` _call

- _call(parameters?): Promise<any>

- #### Parameters

  - `Optional` parameters: SourceParameter

  #### Returns Promise<any>

  Overrides BaseRemoteMethod._call

  - Defined in packages/angular/remote-method/src/lib/proxy.remote-method.ts:33

### applyMetadata

- applyMetadata(partialMetadata): void

- #### Parameters

  - partialMetadata: Partial<BaseRemoteMethodMetadata>

  #### Returns void

  Inherited from BaseRemoteMethod.applyMetadata

  - Defined in packages/angular/definition/src/lib/definition.ts:111

### call

- call(parameters?): Promise<ReturnType>

- #### Parameters

  - `Optional` parameters: SourceParameter

  #### Returns Promise<ReturnType>

  Inherited from BaseRemoteMethod.call

  - Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:76

### destroy

- destroy(): void

- #### Returns void

  #### Deprecated

  use ngOnDestroy instead

  Inherited from BaseRemoteMethod.destroy

  - Defined in packages/angular/definition/src/lib/definition.ts:118

### executed

- executed(result): void

- #### Parameters

  - result: ReturnType

  #### Returns void

  Inherited from BaseRemoteMethod.executed

  - Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:86

### getMetadata

- getMetadata(): BaseRemoteMethodMetadata

- #### Returns BaseRemoteMethodMetadata

  Inherited from BaseRemoteMethod.getMetadata

  - Defined in packages/angular/definition/src/lib/definition.ts:107

### init

- init(): void

- #### Returns void

  Inherited from BaseRemoteMethod.init

  - Defined in packages/angular/definition/src/lib/definition.ts:127

### ngOnDestroy

- ngOnDestroy(): void

- #### Returns void

  Inherited from BaseRemoteMethod.ngOnDestroy

  - Defined in packages/angular/definition/src/lib/definition.ts:122

### pauseRefresh

- pauseRefresh(): void

- #### Returns void

  Inherited from BaseRemoteMethod.pauseRefresh

  - Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:92

### refresh

- refresh(): void

- #### Returns void

  Inherited from BaseRemoteMethod.refresh

  - Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:100

### resumeRefresh

- resumeRefresh(): void

- #### Returns void

  Inherited from BaseRemoteMethod.resumeRefresh

  - Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:96

### `Abstract` transformParameters

- transformParameters(parameters?): TargetParameter | Promise<TargetParameter>

- #### Parameters

  - `Optional` parameters: SourceParameter

  #### Returns TargetParameter | Promise<TargetParameter>

  - Defined in packages/angular/remote-method/src/lib/proxy.remote-method.ts:31

### `Static` add

- add(definition): void

- #### Parameters

  - definition: BaseDefinition<BaseDefinitionMetadata>

  #### Returns void

  Inherited from BaseRemoteMethod.add

  - Defined in packages/angular/definition/src/lib/definition.ts:94

### `Static` remove

- remove(definition): void

- #### Parameters

  - definition: BaseDefinition<BaseDefinitionMetadata>

  #### Returns void

  Inherited from BaseRemoteMethod.remove

  - Defined in packages/angular/definition/src/lib/definition.ts:102